"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.socketSendFile = exports.socketConnect = undefined;var _ws = require("ws");var _ws2 = _interopRequireDefault(_ws);
var _actionNames = require("../constants/actionNames");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}














var CONNECT_TIMEOUT = 3000;
var CONNECT_RETRY = 3000;

var socketConnect = exports.socketConnect = function socketConnect() {return function (dispatch, getState) {
    var server = getState().socket.devServer;
    dispatch({
      type: _actionNames.SOCKET_CONNECT,
      server: server });


    var ws = new _ws2.default(server);

    var timeout = setTimeout(function () {
      ws.close();
      dispatch({
        type: _actionNames.SOCKET_CONNECT_TIMEOUT,
        server: server });

      setTimeout(function () {
        socketConnect()(dispatch, getState);
      }, CONNECT_RETRY);
    }, CONNECT_TIMEOUT);

    ws.on("open", function () {
      clearTimeout(timeout);
      dispatch({
        ws: ws,
        type: _actionNames.SOCKET_CONNECT_SUCCESS,
        server: server });

    });

    ws.on("close", function (code, reason) {
      clearTimeout(timeout);
      dispatch({
        type: _actionNames.SOCKET_CLOSE,
        server: server,
        reason: reason });

      setTimeout(function () {
        socketConnect()(dispatch, getState);
      }, CONNECT_RETRY);
    });

    ws.on("error", function (err) {
      dispatch({
        type: _actionNames.SOCKET_ERROR,
        server: server,
        error: err });

    });

    ws.on("message", function (message) {
      dispatch({
        type: _actionNames.SOCKET_MESSAGE,
        message: message,
        server: server });

    });

    ws.on("unexpected-response", function (request, response) {
      dispatch({
        type: _actionNames.SOCKET_UNEXPECTED_RESPONSE,
        request: request,
        response: response });

    });
  };};

var socketSendFile = exports.socketSendFile = function socketSendFile(file) {return function (dispatch, getState) {
    if (!file.buffer) {
      throw new Error("File is not loaded!");
    }var _getState$socket =
    getState().socket,connected = _getState$socket.connected,ws = _getState$socket.ws;
    if (!connected) {
      // no-op
      return;
    }
    ws.send(
    JSON.stringify({
      type: _actionNames.MESSAGE_FILE,
      path: file.path,
      stat: file.stat }));


    ws.send(file.buffer);
    return dispatch({
      type: _actionNames.SOCKET_SEND_FILE,
      file: file });

  };};