#!/usr/bin/env node
"use strict";Object.defineProperty(exports, "__esModule", { value: true });

var _fs = require("mz/fs");var _fs2 = _interopRequireDefault(_fs);
var _path = require("path");
var _redux = require("redux");
var _reduxThunk = require("redux-thunk");var _reduxThunk2 = _interopRequireDefault(_reduxThunk);
var _commander = require("commander");var _commander2 = _interopRequireDefault(_commander);
var _package = require("../package.json");var _package2 = _interopRequireDefault(_package);
var _terminalComponent = require("./terminal/terminalComponent");var _terminalComponent2 = _interopRequireDefault(_terminalComponent);
var _rootReducer = require("./rootReducer");var _rootReducer2 = _interopRequireDefault(_rootReducer);
var _config = require("./config");var _config2 = _interopRequireDefault(_config);
var _commandActions = require("./command/commandActions");




var _actionNames = require("./constants/actionNames");var actionNames = _interopRequireWildcard(_actionNames);function _interopRequireWildcard(obj) {if (obj && obj.__esModule) {return obj;} else {var newObj = {};if (obj != null) {for (var key in obj) {if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];}}newObj.default = obj;return newObj;}}function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

var configDefault = (0, _path.resolve)(
process.env.HOME,
".streamplace",
"sp-config.yaml");

// const {version} = JSON.parse(pkg);
exports.default = _commander2.default.
version(_package2.default.version).
option(
"--sp-config <file>",
"location of sp-config.yaml (default $HOME/.streamplace/sp-config.yaml)",
configDefault);


var store = (0, _redux.createStore)(_rootReducer2.default, (0, _redux.applyMiddleware)(_reduxThunk2.default));
(0, _terminalComponent2.default)(store);

_commander2.default.
command(actionNames.COMMAND_SYNC.toLowerCase()).
description("sync your plugin to a development server").
option("--dev-server <url>", "url of your development server").
action(function (command) {
  store.dispatch(
  (0, _commandActions.commandSync)({
    devServer: command.devServer }));


});

_commander2.default.
command(actionNames.COMMAND_SERVE.toLowerCase()).
description("[in-cluster only] run a development server").
option(
"--port <number>",
"port to listen for incoming websocket connections",
"80").

action(function (command) {
  store.dispatch(
  (0, _commandActions.commandServe)({
    port: command.port }));


});

_commander2.default.
command(actionNames.COMMAND_BUILD.toLowerCase()).
description("build a streamplace plugin").
option(
"--docker-prefix <name>",
"prefix of built Docker images (default streamplace)",
"streamplace").

option(
"--docker-tag <name>",
"tag of built Docker images (default latest)",
"latest").

option("--dev-server <url>", "url of your development server").
action(function (command) {
  store.dispatch(
  (0, _commandActions.commandBuild)({
    dockerPrefix: command.dockerPrefix,
    dockerTag: command.dockerTag,
    directory: process.cwd() }));


});

_commander2.default.parse(process.argv);

if (!process.argv.slice(2).length) {
  _commander2.default.outputHelp();
}