"use strict";Object.defineProperty(exports, "__esModule", { value: true });var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};exports.default =



































terminalReducer;var _actionNames = require("../constants/actionNames");var actions = _interopRequireWildcard(_actionNames);function _interopRequireWildcard(obj) {if (obj && obj.__esModule) {return obj;} else {var newObj = {};if (obj != null) {for (var key in obj) {if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key];}}newObj.default = obj;return newObj;}}function _toConsumableArray(arr) {if (Array.isArray(arr)) {for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {arr2[i] = arr[i];}return arr2;} else {return Array.from(arr);}}function addEntry(state, category, text) {return _extends({}, state, { entries: [].concat(_toConsumableArray(state.entries), [{ category: category, text: text }]) });}var initialState = { title: { color: [255, 207, 0], text: "Streamplace" }, status: { color: [255, 0, 0], text: "Disconnected" }, categories: { debug: { name: "debug", color: [0, 255, 255] }, watcher: { name: "watcher", color: [100, 255, 100] }, socket: { name: "socket", color: [100, 100, 255] } }, bottomBar: false, entries: [] };function terminalReducer() {var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;var action = arguments[1];
  switch (action.type) {
    case actions.COMMAND_SYNC:
      return _extends({}, state, { bottomBar: true });

    case actions.WATCHER_READY:
      return addEntry(state, "watcher", "Watcher ready!");

    case actions.WATCHER_ADD:
      return addEntry(state, "watcher", "File added: " + action.path);

    case actions.WATCHER_CHANGE:
      return addEntry(state, "watcher", "File changed: " + action.path);

    case actions.WATCHER_UNLINK:
      return addEntry(state, "watcher", "File deleted: " + action.path);

    case actions.WATCHER_LOAD_FILE_SUCCESS:
      return addEntry(state, "watcher", "File loaded: " + action.path);

    case actions.WATCHER_LOAD_FILE_ERROR:
      return addEntry(
      state,
      "watcher", "Error loading file " +
      action.path + ": " + action.error);


    case actions.SERVER_LISTEN_SUCCESS:
      return addEntry(
      state,
      "socket", "Streamplace dev server listening on port " +
      action.port);


    case actions.SOCKET_CONNECT:
      return addEntry(
      state,
      "socket", "Attempting connection to " +
      action.server);


    case actions.SOCKET_CONNECT_SUCCESS:
      state = addEntry(state, "socket", "Opened connection " + action.server);
      return _extends({},
      state, {
        status: {
          color: [0, 255, 0],
          text: "Connected" } });



    case actions.SOCKET_ERROR:
      state = addEntry(state, "socket", "Socket error " + action.error);
      return _extends({},
      state, {
        status: initialState.status });


    case actions.SOCKET_CLOSE:
      state = addEntry(
      state,
      "socket", "Connection to " +
      action.server + " closed");

      return _extends({},
      state, {
        status: initialState.status });}



  return state;
}